package com.njcn.csharmonic.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csharmonic.api.WavePicFeignClient;
import com.njcn.csharmonic.pojo.vo.CsEventVO;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @author xy
 */
@Slf4j
@Component
public class WavePicClientFallbackFactory implements FallbackFactory<WavePicFeignClient> {
    @Override
    public WavePicFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new WavePicFeignClient() {
            @Override
            public HttpResult<CsEventVO> getWavePics(String eventId) {
                log.error("{}异常，降级处理，异常为：{}","获取事件波形图",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<Boolean> updateEventById(String id) {
                log.error("{}异常，降级处理，异常为：{}","修改事件信息异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
